type file;
type aux {
   file phr;
   file pin;
   file psq;
};

file inputs[] <ext; exec="./inmapper">;
aux auxiliary[] <ext; exec="./medmapper">;
file reciprocalScript <"simple_reciprocal_best_hits.01b.pl">;

(file phr, file pin, file psq) formatdb (file input)
{
 app { formatdb "-i" @input; }
}

(file output) blast(file input1,  aux intermed1, file input2, aux intermed2)
{
  app{
    blastall "-p" "blastp" "-d" @input1 "-i" @input2 "-m" "9" "-o" @output;
  }
}

(file output) reciprocal(file reciprocalScript, file input1, file input2) {
 app { perl @reciprocalScript  "-i1" @input1 "-i2" @input2 "-o" @output; }
}

foreach input_f, i in inputs {
  (auxiliary[i].phr, auxiliary[i].pin, auxiliary[i].psq) = 
    formatdb(input_f); //constructs the auxiliary files needed in blast step
}


foreach i, i_index in inputs {
  foreach j, j_index in inputs  {
       file output1  <single_file_mapper; file=@strcat("out", @i, "2", @j, ".txt")>;
       output1 = blast(inputs[i], auxiliary[i], inputs[j], auxiliary[j]);
/*
       file output2  <single_file_mapper; file=@strcat("out", @j, "2", @i, ".txt")>;
       output2 = blast(inputs[j], auxiliary[j], inputs[i], auxiliary[i]);
       file output  <single_file_mapper; 
       file=@strcat("ortholog.pairs.",@(i.faa),"-",@(j.faa),".txt")>;
       output = reciprocal(reciprocalScript, output1, output2);
*/
  }
}

